
extern void 	error_message(char *fmt, ...);
extern void 	error_exit(char *fmt, ...);

extern void port_write(char ch);
extern void port_write_str(unsigned char *s, int len);

extern char	*tty_fontname;
extern BOOL	mode_fix_window_size;
extern COLORREF	colour_background;
extern COLORREF	colour_cursor;
extern COLORREF	colour_cursor_text;
extern COLORREF	colour_text;
extern COLORREF	colour_bold;
extern int	font_height;
extern int	font_width;
extern char	*terminal_type;
extern int	max_screen_history;

extern void	tty_startup(void);
extern void	tty_init(HWND hWnd);
extern void	tty_set_size(int cols, int rows);
extern void	tty_show_history(int, int);
extern void	tty_show_lastest(void);
extern void	tty_terminate(void);
extern void	tty_output(int ch);
extern void	tty_output_str(LPSTR fmt, ...);
extern void	tty_refresh(HWND hWnd, HDC hdc);
extern void	tty_repaint(HWND hWnd, HDC hdc);
extern void	tty_do_blink(void);


extern void	tty_move_cursor(int, int);
extern void	tty_cursor_home(void);
extern void	tty_cursor_up(int);
extern void	tty_cursor_down(int);
extern void	tty_cursor_up_scroll(void);
extern void	tty_cursor_down_scroll(void);
extern void	tty_cursor_left(int);
extern void	tty_cursor_right(int);
extern void	tty_clear_screen(void);
extern void	tty_clear_to_eol(void);
extern void	tty_clear_from_bol(void);
extern void	tty_clear_to_eos(void);
extern void	tty_save_cursor(void);
extern void	tty_restore_cursor(void);
extern int	tty_get_attr(void);
extern void	tty_set_attr(int);
extern void	tty_cursor_on(void);
extern void	tty_cursor_off(void);
extern void	tty_echo(int);
extern int	tty_telnet_controls(unsigned char *, int);
extern void	tty_scroll_up(void);
extern void	tty_scroll_down(void);
extern void	tty_set_scroll_region(int, int);
extern void	tty_insert_lines(int);
extern void	tty_insert_chars(int);
extern void	tty_delete_lines(int);
extern void	tty_delete_chars(int);
extern void	tty_send_cursor_position(void);
extern void	tty_save_state(void);
extern void	tty_restore_state(void);
extern void	tty_mouse_select(int, int, int);
extern void	tty_set_insert_mode(int);
extern void	tty_foreground_colour(int);
extern void	tty_background_colour(int);

extern void	tty_clear_tab_stops(void);
extern void	tty_default_tab_stops(void);
extern void	tty_set_tab_stop(void);

#define ZATTR_COLOUR_MASK	0xff000000
#define ZATTR_COLOUR_FG_SET	0x08000000
#define ZATTR_COLOUR_BG_SET	0x80000000
#define ZATTR_COLOUR_FG(x)	((x & 0x07000000) >> 24)
#define ZATTR_COLOUR_BG(x)	((x & 0x70000000) >> 28)

#define ZATTR_NORMAL	0x00000000
#define ZATTR_BOLD	0x00010000
#define ZATTR_BLINK	0x00020000
#define ZATTR_UNDERLINE	0x00040000
#define ZATTR_DIM	0x00080000
#define ZATTR_REVERSE	0x00100000
#define ZATTR_CURSOR	0x00200000
#define ZATTR_SELECT	0x00400000
#define ZATTR_MASK	0xffff0000

#define ZGR_H_LINE	0x00000100
#define ZGR_V_LINE	0x00000200
#define ZGR_TL_CORNER	0x00000300
#define ZGR_TR_CORNER	0x00000400
#define ZGR_BL_CORNER	0x00000500
#define ZGR_BR_CORNER	0x00000600
#define ZGR_TEE_LEFT	0x00000700
#define ZGR_TEE_RIGHT	0x00000800
#define ZGR_TEE_TOP	0x00000900
#define ZGR_TEE_BOTTOM	0x00000a00
#define ZGR_CROSS	0x00000b00
#define ZGR_MASK	0x0000ff00


#define ZKEY_UP		1000
#define ZKEY_DOWN	1001
#define ZKEY_LEFT	1002
#define ZKEY_RIGHT	1003
#define ZKEY_PGUP	1004
#define ZKEY_PGDOWN	1005
#define ZKEY_HOME	1006
#define ZKEY_END	1007
#define ZKEY_INSERT	1008
#define ZKEY_DELETE	1009
#define ZKEY_BACKSPACE	1010
#define ZKEY_FIND	1011
#define ZKEY_REMOVE	1012
#define ZKEY_SELECT	1013

#define ZKEY_PF1		1101
#define ZKEY_PF2		1102
#define ZKEY_PF3		1103
#define ZKEY_PF4		1104

#define ZKEY_F1		1201
#define ZKEY_F2		1202
#define ZKEY_F3		1203
#define ZKEY_F4		1204
#define ZKEY_F5		1205
#define ZKEY_F6		1206
#define ZKEY_F7		1207
#define ZKEY_F8		1208
#define ZKEY_F9		1209
#define ZKEY_F10	1210
#define ZKEY_F11	1211
#define ZKEY_F12	1212
#define ZKEY_F13	1213
#define ZKEY_F14	1214
#define ZKEY_F15	1215
#define ZKEY_F16	1216
#define ZKEY_F17	1217
#define ZKEY_F18	1218
#define ZKEY_F19	1219
#define ZKEY_F20	1220


#define MOUSE_SELECT_START	0
#define MOUSE_SELECT_MOVE	1
#define MOUSE_SELECT_END	2
#define MOUSE_SELECT_WORD	3
#define MOUSE_SELECT_EXTENT	4

